//---------------------------------------------------------------------------
// Pre-compilation
#include "MediaInfo/PreComp.h"
#ifdef __BORLANDC__
    #pragma hdrstop
#endif
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
#include "DMS/MediaInfo_Mappings.h"
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
namespace MediaInfoLib
{

String MediaInfo_To_Codec_Category (MediaInfo &MI, stream_t StreamKind, size_t StreamPos)
{
    MediaInfoLib::String Format=                MI.Get(StreamKind, StreamPos, __T("Format")               );
    MediaInfoLib::String Format_Version=        MI.Get(StreamKind, StreamPos, __T("Format_Version")       );
    MediaInfoLib::String Format_Profile=        MI.Get(StreamKind, StreamPos, __T("Format_Profile")       );
    MediaInfoLib::String CodecID=               MI.Get(StreamKind, StreamPos, __T("CodecID")              );
    MediaInfoLib::String CodecID_Hint=          MI.Get(StreamKind, StreamPos, __T("CodecID/Hint")         );

    if (StreamKind==MediaInfoLib::Stream_Video)
    {
             if (Format==__T("AVC"))
            return __T("H.264/AVC");
        else if (Format==__T("AVS"))
            return String(); // Not in the list
        else if (Format==__T("CineForm"))
            return __T("Cineform");
        else if (Format==__T("Dirac"))
            return __T("Dirac");
        else if (Format==__T("DV"))
            return __T("DV");
        else if (Format==__T("DPX"))
            return __T("DPX"); 
        else if (Format==__T("EXR"))
            return __T("EXR");
        else if (Format==__T("H.263"))
            return __T("H.263");
        else if (Format==__T("HEVC"))
            return __T("H.265/HEVC");
        else if (Format==__T("JPEG"))
            return __T("Motion JPEG");
        else if (Format==__T("JPEG 2000"))
        {
            if (CodecID_Hint==__T("R3D"))
                return __T("RED");
            else
                return __T("JPEG2000");
        }
        else if (Format==__T("MPEG Video"))
        {
            if (Format_Version==__T("Version 1"))
                return __T("MPEG 1");
            if (Format_Version==__T("Version 2"))
                return __T("MPEG 2");
        }
        else if (Format==__T("MPEG-4 Visual"))
            return __T("MPEG 4 Visual");
	    else if (Format==__T("PNG"))
            return __T("PNG");
	    else if (Format==__T("ProRes"))
            return __T("ProRes");
        else if (Format.find(__T("RealVideo "))==0)
            return __T("Real Video"); 
        else if (Format==__T("RGB"))
            return __T("RAW");
        else if (Format==__T("VC-1"))
        {
            if (CodecID==__T("WMV3"))
                return __T("WMV"); 
            return __T("VC-1");
        }
        else if (Format==__T("VC-3"))
            return __T("Avid DNxHD"); 
        else if (Format==__T("VP6"))
            return __T("VP-6/7"); 
        else if (Format==__T("VP7"))
            return __T("VP-6/7"); 
        else if (Format==__T("WMV1"))
            return __T("WMV"); 
        else if (Format==__T("WMV2"))
            return __T("WMV"); 
        else if (Format==__T("YUV"))
        {
            if (CodecID==__T("V210") || CodecID==__T("v210"))
                return __T("V210"); 
            return __T("RAW"); 
        }
    }

    if (StreamKind==MediaInfoLib::Stream_Audio)
    {
             if (Format==__T("AAC"))
            return __T("AAC");
        else if (Format==__T("AC-3"))
            return __T("Dolby AC-3");
        else if (Format==__T("ADPCM"))
            return __T("ADPCM");
        else if (Format==__T("Dolby E"))
            return __T("Dolby E");
        else if (Format==__T("DTS"))
            return __T("DTS");
        else if (Format==__T("FLAC"))
            return __T("FLAC");
        else if (Format==__T("G.728"))
            return __T("Real Audio");
        else if (Format==__T("PCM"))
            return __T("PCM Audio");
        else if (Format==__T("MLP"))
            return __T("Dolby TrueHD/MLP");
        else if (Format==__T("MPEG Audio"))
        {
            if (Format_Profile==__T("Layer 3"))
                return __T("MP3");
            return __T("MPEG Audio");
        }
        else if (Format.find(__T("TrueHD"))==0)
            return __T("Dolby TrueHD/MLP");
        else if (Format==__T("Vorbis"))
            return __T("Vorbis");
        else if (Format==__T("VSELP"))
            return __T("Real Audio");
        else if (Format.find(__T("WMA"))==0)
            return __T("WMA");
    }

    if (StreamKind==MediaInfoLib::Stream_Text)
    {
             if (Format==__T("ASS"))
            return __T("ASS");
        else if (Format==__T("DVB Subtitle"))
            return __T("DVB subtitle");
        else if (Format==__T("EIA-608"))
            return __T("CEA-608");
        else if (Format==__T("EIA-708"))
            return __T("CEA-708");
        else if (Format==__T("ARIB STD B24/B37"))
            return __T("ARIB STD B24/B37");
        else if (Format==__T("TTML"))
            return __T("TTML");
        else if (Format==__T("Teletext Subtitle"))
            return __T("Teletext subtitle");
        else if (Format==__T("PGS"))
            return __T("Blu-ray subtitle");
        else if (Format==__T("RLE"))
            return __T("DVD subtitle");
        else if (Format==__T("SSA"))
            return __T("SSA");
        else if (Format==__T("SubRip"))
            return __T("SubRip");
        else if (Format==__T("WebVTT"))
            return __T("WebVTT");
         else if (Format==__T("N19"))
            return __T("N19/STL");
         else if (Format==__T("Teletext"))
            return __T("Teletext");
         else if (Format==__T("Teletext Subtitle"))
            return __T("Teletext Subtitle");
    }

    return String();
}

}